import Joi from 'joi';
import { BaseIdToken } from './auth-base-token';
import { AppDomain } from './auth-type';
export declare type VerifyIdToken = BaseIdToken & {
    productEntityId: number;
    roleId: number;
    rules: string;
};
export declare const schemaVerifyIdToken: {
    productEntityId: Joi.NumberSchema;
    roleId: Joi.NumberSchema;
    rules: Joi.StringSchema;
    appDomain: Joi.StringSchema;
    userId: Joi.NumberSchema;
    userName: Joi.StringSchema;
    localeCode: Joi.StringSchema;
};
export declare type AuthBearerVerify = (token: string) => Promise<VerifyIdToken>;
export declare type BasicMetadata = {
    username: string;
    password: string;
    appDomain?: AppDomain;
};
export declare type AuthBasicVerify = (params: BasicMetadata) => Promise<VerifyIdToken>;
