import { Ability } from '@casl/ability';
import { IdToken } from './auth-id-token';
import { BasicMetadata } from './auth-type-verify';
export declare enum AuthTokenType {
    Bearer = "Bearer",
    Basic = "Basic"
}
export declare enum AppDomain {
    MERCHANT = "MERCHANT",
    CONSUMER = "CONSUMER",
    ADMIN = "ADMIN",
    ROUTER = "ROUTER"
}
export declare type AuthToken = {
    type: AuthTokenType;
    info: AccessInfo;
    grant?: boolean;
};
export declare type AccessInfo = {
    token: string;
    auth?: IdToken;
    authMetadata?: BasicMetadata;
    headers?: {
        appDomain: AppDomain;
        localeCode: string;
    };
    requestedBy?: number;
    requestedByName?: string;
};
export declare type Rule = {
    action: string;
    subject: string;
};
export declare type AuthDirective = {
    type: AuthTokenType;
    hasAbility?: Rule;
};
export declare function generateAbility(rules: string): Ability<import("@casl/ability").AbilityTuple<string, import("@casl/ability").Subject>, import("@casl/ability").MongoQuery<import("@casl/ability/dist/types/types").AnyObject>>;
